Subject: Feature request

From: Erik Demaine <[email-masked]>
Date: Wed, 22 Sep 1999 15:40:14 -0400 (EDT)

I just joined this mailing list, so please forgive my ignorance:
Is this the right place to send feature requests?  Do the pine developers
read this mailing list?

A brief description of my request:
The ability to specify the Content-Transfer-Encoding, in particular to
allow specifying "7bit" with no encoding (the identity encoding).

I just read the tech-notes in Pine 4.10.  The section "MIME: Sending a Message"
states:

    MIME has two ways of encoding data-Quoted-Printable and Base64.
    Quoted-Printable leaves the ASCII text alone and only changes 8-bit
    characters to "=" followed by the hex digits.
    [...]
    All attachments are encoded using Base64 encoding. This is so that the
    attachment will arrive at the other end looking exactly like it did
    when it was sent. Since Base64 is completely unreadable except by
    MIME-capable mailers or programs, there is an obvious tradeoff being
    made here. We chose to ensure absolutely reliable transport of
    attachments at the cost of requiring a MIME-capable mailer to read
    them. If the user doesn't want absolute integrity he or she may always
    include text (with the ^R command) in the body of a message instead of
    attaching it.

This is not exactly true about MIME only having two encodings.  There is
a third encoding: the identity transform.  Here are details from the MIME
standard (http://www.oac.uci.edu/indiv/ehood/MIME/MIME.html, MIME Part One,
Section 6):

    The Content-Transfer-Encoding values "7bit", "8bit", and "binary" all mean
    that the identity (i.e. NO) encoding transformation has been performed. As
    such, they serve simply as indicators of the domain of the body data, and
    provide useful information about the sort of encoding that might be needed
    for transmission in a given transport system. The terms "7bit data", "8bit
    data", and "binary data" are all defined in Section 2.

    The quoted-printable and base64 encodings transform their input from an
    arbitrary domain into material in the "7bit" range, thus making it safe to
    carry over restricted transports. The specific definition of the
    transformations are given below.  [...]

I would like to be able to use the identity transform on attachments.  My
reason is this: I often want to attach a PostScript to several people, most of
which can support MIME, but occasionally someone can't.  (And I can't predict
ahead of time who can.)  My PostScript documents are always 7bit, and never
start with a From line.  If it were encoded in text, then even someone without
a MIME-supporting mail reader could very easily extract the file.

Would it be possible to add an option to pine to switch to specifying 7bit or
8bit or binary?  I can imagine several alternatives.  The simplest would be to
allow specifying an option during mail composition.  I have seen several mail
readers that allow specifying "text" as the encoding format, and allow
specifying the character set (iso8859-1 implies 8bit, and us-ascii implies
7bit).  More interesting might be to change the encoding depending on the file;
e.g., have a config option that, when enabled, automatically uses a 7bit or
8bit encoding if the file is expected to be transferred okay (staying in a
reasonable character set, and no leading From lines).

Opinions?
Erik
-- 
Erik Demaine              \)  e-mail: [email-masked] (PGP avail.)
Dept. of Computer Science  \( URL: http://daisy.uwaterloo.ca/~eddemain/
University of Waterloo     )\ "The world would be a much nicer place if
Waterloo, ON Canada N2L 3G1 (\ everything were convex." -Bernard Chazelle

-- 
-----------------------------------------------------------------
 For information about this mailing list, and its archives, see: 
 http://www.washington.edu/pine/pine-info/
-----------------------------------------------------------------